---
- name: Set default facts for K8S
  ansible.builtin.set_fact:
    k8s_config: "{{ K8S_KUBECONFIG_PATH }}/{{ inv_idm.ns_kubeconfig }}"
    k8s_context: "{{ inv_k8s.config.context }}"
    k8s_namespace: "{{ inv_idm.ns_name }}"

- name: "Create namespace {{ k8s_namespace }}"
  kubernetes.core.k8s:
    state: present
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    definition:
      api_version: v1
      kind: Namespace
      metadata:
        name: "{{ k8s_namespace }}"
        labels:
          name: "{{ k8s_namespace }}"
  when: inv_idm.ns_create == "true"

# Create extra namespace, DB instance has to be deployed externally
- name: "Create namespace {{ inv_idm.db_ns_name }}"
  kubernetes.core.k8s:
    state: present
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    definition:
      api_version: v1
      kind: Namespace
      metadata:
        name: "{{ inv_idm.db_ns_name }}"
        labels:
          name: "{{ inv_idm.db_ns_name }}"
  when: inv_idm.ns_create == "true"

# 2. Setup PostgreSQL database via Zalando operator
- name: Setup PostgreSQL database for KeyCloak Operator
  import_tasks: tasks/04_idm_keycloak/setup_keycloak_db.yml
  when: inv_op_stack.keycloak_operator.enable == "true"
  tags: keycloak_db

# 3. Setup KeyCloak
- name: Setup KeyCloak Administrator
  import_tasks: tasks/04_idm_keycloak/setup_keycloak.yml
  tags: keycloak_setup

# 3. Setup velero backup
- name: "Create velero Backup schedule namespace {{ k8s_namespace }} "
  kubernetes.core.k8s:
    state: present
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    namespace: "{{ inv_op_stack.velero.ns_name }}"
    definition:
      apiVersion: velero.io/v1
      kind: Schedule
      metadata:
        name: "{{ k8s_namespace }}-backup"
      spec:
        schedule: 0 2 * * *
        template:
          defaultVolumesToRestic: true
          hooks: {}
          includedNamespaces:
            - '{{ k8s_namespace }}'
          metadata: {}
          snapshotVolumes: true
          storageLocation: "{{ inv_op_stack.velero.backup.location_name }}-backup"
          ttl: 720h0m0s
  when: inv_op_stack.velero.enable == "true"

# 4. Setup velero backup
- name: "Create velrero Backup schedule extra naemspace {{ inv_idm.db_ns_name }}"
  kubernetes.core.k8s:
    state: present
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    namespace: "{{ inv_op_stack.velero.ns_name }}"
    definition:
      apiVersion: velero.io/v1
      kind: Schedule
      metadata:
        name: "{{ inv_idm.db_ns_name }}-backup"
      spec:
        schedule: 0 2 * * *
        template:
          defaultVolumesToRestic: true
          hooks: {}
          includedNamespaces:
            - '{{ inv_idm.db_ns_name }}'
          metadata: {}
          snapshotVolumes: true
          storageLocation: "{{ inv_op_stack.velero.backup.location_name }}-backup"
          ttl: 720h0m0s
  when: inv_op_stack.velero.enable == "true"
